
// RGB-HistogramDlg.cpp :  
//

#include "stdafx.h"
#include "RGB-Histogram.h"
#include "RGB-HistogramDlg.h"
#include "afxdialogex.h"
#include <map>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//  α׷  Ǵ CAboutDlg ȭ Դϴ.

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// ȭ  Դϴ.
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

// Դϴ.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CRGBHistogramDlg ȭ 



CRGBHistogramDlg::CRGBHistogramDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CRGBHistogramDlg::IDD, pParent),
	m_hBitMap(NULL)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	memset(m_Red, 0, sizeof(m_Red));
	memset(m_Green, 0, sizeof(m_Green));
	memset(m_Blue, 0, sizeof(m_Blue));
}

void CRGBHistogramDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CRGBHistogramDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CRGBHistogramDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CRGBHistogramDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_RADIO1, &CRGBHistogramDlg::OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, &CRGBHistogramDlg::OnBnClickedRadio2)
END_MESSAGE_MAP()


// CRGBHistogramDlg ޽ ó

BOOL CRGBHistogramDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ý ޴ "..." ޴ ׸ ߰մϴ.

	// IDM_ABOUTBOX ý   ־ մϴ.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// ⿡ ߰ ʱȭ ۾ ߰մϴ.
	((CButton*)GetDlgItem(IDC_RADIO2))->SetCheck(TRUE);

	//PrintHistogram();

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

void CRGBHistogramDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CRGBHistogramDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮԴϴ.

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CRGBHistogramDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CRGBHistogramDlg::InitData()
{
	::DeleteObject(m_hBitMap);
	memset(m_Red, 0, sizeof(m_Red));
	memset(m_Green, 0, sizeof(m_Green));
	memset(m_Blue, 0, sizeof(m_Blue));
}

void CRGBHistogramDlg::OnBnClickedButton1()
{
	CFileDialog dlg(TRUE, _T("*.*"), _T("*.bmp;*.png;*.jpg;*.gif"));
	int result = dlg.DoModal();
	if(result == IDOK)
	{
		InitData();
		
		CImage image;
		HRESULT hResult = image.Load(dlg.GetPathName());
		if (FAILED(hResult))
		{
			AfxMessageBox(_T("Failed to load image file"));
			return;
		}

		m_hBitMap = image.Detach();
		DrawThumbnail();
		PrintHistogram();
	}
}

void CRGBHistogramDlg::DrawGraph(int x, int y, unsigned int data[], const COLORREF rgb)
{
	CClientDC dc(this);
	unsigned int width = 257;
	unsigned int height = 110;

	unsigned int data_print[256] = {0,};

	// Draw Background
	CPen pen;
	pen.CreatePen(PS_SOLID, 1, RGB(150,150,150));
	CPen *oldPen = dc.SelectObject(&pen);
	dc.Rectangle(x, y, x + width, y + height);
	dc.SelectObject(oldPen);

	// Normalize
	unsigned int max_n = 0;
	for (int i = 0; i < 256; ++i)
		if (data[i] > max_n) max_n = data[i];
	double ratio = max_n ? (1.0 * (height - 1) / max_n) : 0.0;

	// Adjust Scale
	double adjust = 1.0;
	double min_threshold = 0.24; // 24%
	unsigned int min_threshold_cnt = (unsigned int)(height * width * min_threshold);
	unsigned int cnt = 0;
	
	while (1)
	{
		cnt = 0;
		for (int i = 0; i < 256; ++i)
			cnt += (unsigned int)((data[i] * adjust) * ratio);

		if (cnt == 0 || cnt > min_threshold_cnt)
			break;

		adjust += 0.1;
	}

	if (((CButton*)GetDlgItem(IDC_RADIO1))->GetCheck() == TRUE)
		adjust = 1.0;
	
	// Set data
	for (int i = 0; i < 256; ++i)
		data_print[i] = (unsigned int)((data[i] * adjust) * ratio);

	// Draw Graph
	CPen penData;
	penData.CreatePen(PS_SOLID, 1, rgb);
	oldPen = dc.SelectObject(&penData);

	for (int i = 0; i < 256; ++i)
	{
		if (data_print[i] ==  0) continue;

		dc.MoveTo(x + i, y + height - 2);
		dc.LineTo(x + i, y + height - (data_print[i] > height ? height : data_print[i]) - 1);
	}
	dc.SelectObject(oldPen);
}

void CRGBHistogramDlg::DrawThumbnail()
{
	CClientDC dc(this);
	HDC memDC = CreateCompatibleDC(dc.GetSafeHdc());

	HBITMAP hold_bm = (HBITMAP)SelectObject(memDC, m_hBitMap);
	BITMAP bm;
	GetObject(m_hBitMap, sizeof(BITMAP), &bm);

	RECT rect;
	GetDlgItem(IDC_STATIC_PIC1)->GetWindowRect(&rect);
	ScreenToClient(&rect);

	SetStretchBltMode(dc.GetSafeHdc(), HALFTONE);
	StretchBlt(dc.GetSafeHdc(), rect.left, rect.top, 200, 200, memDC, 0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);

	SelectObject(memDC, hold_bm);
	DeleteDC(memDC);
}

void CRGBHistogramDlg::PrintHistogram()
{
	CBitmap bitmap;
	if (m_hBitMap)
	{
		// Set Data
		bitmap.Attach(m_hBitMap);

		BITMAP bm_info;
		bitmap.GetBitmap(&bm_info);

		int bm_bps = bm_info.bmBitsPixel / 8;
		int bm_size = bm_info.bmWidth * bm_info.bmHeight * bm_bps;
		BYTE *p_bit_pattern = new BYTE[bm_size];
		bitmap.GetBitmapBits(bm_size, p_bit_pattern);

		for (int pos = 0; pos < bm_size; pos += bm_bps)
		{
			++m_Red[p_bit_pattern[2 + pos]];
			++m_Green[p_bit_pattern[1 + pos]];
			++m_Blue[p_bit_pattern[pos]];
		}

		free(p_bit_pattern);
	}

	// Red
	DrawGraph(20, 10, m_Red, RGB(255, 0, 0));

	// Green
	DrawGraph(20, 130, m_Green, RGB(0, 255, 0));

	// Blue
	DrawGraph(20, 250, m_Blue, RGB(0, 0, 255));
}

void CRGBHistogramDlg::Reload()
{
	// Red
	DrawGraph(20, 10, m_Red, RGB(255, 0, 0));

	// Green
	DrawGraph(20, 130, m_Green, RGB(0, 255, 0));

	// Blue
	DrawGraph(20, 250, m_Blue, RGB(0, 0, 255));
}

void CRGBHistogramDlg::OnBnClickedButton2()
{
	Reload();
}

void CRGBHistogramDlg::OnBnClickedRadio1()
{
	Reload();
}

void CRGBHistogramDlg::OnBnClickedRadio2()
{
	Reload();
}
